
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Spring Cloud构建微服务架构-Hystrix服务降级 / 憋错料</title>

    <meta name="description" content="Spring Cloud构建微服务架构-Hystrix服务降级 在微服务架构中,我们将系统拆分成了一个个的服务单元,各单元应用间通过服务注册与订阅的方式互相依赖.由于每个单元都在不同的进程中运行,依赖通过远程调用的方式执行,这样就有可能因为网络原因或是依赖服务自身问题出现调用故障或延迟,而这些问题会直接导致调用方的对外服务也出现延迟,若此时调用方的请求不断增加,最后就会出现因等待出现故障的依赖方响应而形成任务积压,线程资源无法释放,最终导致自身服务的瘫痪,进一步甚至出现故障的蔓延最终导致整个系统的瘫痪.如果这样的架构存在如此严重的隐患,那么相较传统架构就更加">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Spring Cloud构建微服务架构-Hystrix服务降级</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>在微服务架构中，我们将系统拆分成了一个个的服务单元，各单元应用间通过服务注册与订阅的方式互相依赖。由于每个单元都在不同的进程中运行，依赖通过远程调用的方式执行，这样就有可能因为网络原因或是依赖服务自身问题出现调用故障或延迟，而这些问题会直接导致调用方的对外服务也出现延迟，若此时调用方的请求不断增加，最后就会出现因等待出现故障的依赖方响应而形成任务积压，线程资源无法释放，最终导致自身服务的瘫痪，进一步甚至出现故障的蔓延最终导致整个系统的瘫痪。如果这样的架构存在如此严重的隐患，那么相较传统架构就更加的不稳定。为了解决这样的问题，因此产生了断路器等一系列的服务保护机制。</p>
<p>针对上述问题，在Spring Cloud Hystrix中实现了线程隔离、断路器等一系列的服务保护功能。它也是基于Netflix的开源框架 Hystrix实现的，该框架目标在于通过控制那些访问远程系统、服务和第三方库的节点，从而对延迟和故障提供更强大的容错能力。Hystrix具备了服务降级、服务熔断、线程隔离、请求缓存、请求合并以及服务监控等强大功能。</p>
<p>接下来，我们就从一个简单示例开始对Spring Cloud Hystrix的学习与使用。</p>
<p>在开始使用Spring Cloud Hystrix实现断路器之前，我们先拿之前实现的一些内容作为基础，其中包括：</p>
<p>eureka-server工程：服务注册中心，端口：1001<br />eureka-client工程：服务提供者，两个实例启动端口分别为2001<br />下面我们可以复制一下之前实现的一个服务消费者：eureka-consumer-ribbon，命名为eureka-consumer-ribbon-hystrix。下面我们开始对其进行改在：</p>
<p>第一步：pom.xml的dependencies节点中引入spring-cloud-starter-hystrix依赖：</p>
<p>&lt;dependency&gt;<br />&lt;groupId&gt;org.springframework.cloud&lt;/groupId&gt;<br />&lt;artifactId&gt;spring-cloud-starter-hystrix&lt;/artifactId&gt;<br />&lt;/dependency&gt;<br />第二步：在应用主类中使用@EnableCircuitBreaker或@EnableHystrix注解开启Hystrix的使用：</p>
<p>@EnableCircuitBreakerbr/&gt;@EnableDiscoveryClient<br />@SpringBootApplication<br />public class Application {<a href="/cdn-cgi/l/email-protection#3a584815047a785f5b5406584815">br/&gt;@Bean<br />@LoadBalanced<br />public RestTemplate restTemplate() {<br />return new RestTemplate();<br />}<br />public static void main(String[] args) {<br />new SpringApplicationBuilder(Application.class).web(true).run(args);<br />}<br />}<br />注意：这里我们还可以使用Spring Cloud应用中的@SpringCloudApplication注解来修饰应用主类，该注解的具体定义如下所示。我们可以看到该注解中包含了上我们所引用的三个注解，这也意味着一个Spring Cloud标准应用应包含服务发现以及断路器。</p>
<p>@Target({ElementType.TYPE})<a href="/cdn-cgi/l/email-protection#debcacf1e09e8cbbaabbb0aab7b1b0f68cbbaabbb0aab7b1b08eb1b2b7bda7f08c8b908a97939bf7e2bcacf1">br/&gt;@Retention(RetentionPolicy.RUNTIME)<br />@Documented<a href="/cdn-cgi/l/email-protection#d0b2a2ffee9099beb8b5a2b9a4b5b4ecb2a2ff">br/&gt;@Inherited<br />@SpringBootApplication<a href="/cdn-cgi/l/email-protection#197b6b3627595c77787b757c5d706a7a766f7c6b605a75707c776d257b6b36">br/&gt;@EnableDiscoveryClient<br />@EnableCircuitBreaker<br />public @interface SpringCloudApplication {<br />}<br />第三步：改造服务消费方式，新增ConsumerService类，然后将在Controller中的逻辑迁移过去。最后，在为具体执行逻辑的函数上增加@HystrixCommand注解来指定服务降级方法，比如：</p>
<p>@RestController<br />public class DcController {<a href="/cdn-cgi/l/email-protection#a8cada8796e8e9dddcc7dfc1dacdcc94cada87">br/&gt;@Autowired<br />ConsumerService consumerService;<a href="/cdn-cgi/l/email-protection#0664742938464163724b6776766f68612e">br/&gt;@GetMapping("/consumer")<br />public String dc() {<br />return consumerService.consumer();<br />}<br />class ConsumerService {<a href="/cdn-cgi/l/email-protection#88eafaa7b6c8c9fdfce7ffe1faedecb4eafaa7">br/&gt;@Autowired<br />RestTemplate restTemplate;<br />@HystrixCommand(fallbackMethod = &quot;fallback&quot;)<br />public String consumer() {<br />return restTemplate.getForObject(&quot;<a href="http://eureka-client/dc">http://eureka-client/dc&quot;, String.class);<br />}<br />public String fallback() {<br />return &quot;fallback&quot;;<br />}<br />}<br />}<br />下面我们来验证一下上面Hystrix带来的一些基础功能。我们先把涉及的服务都启动起来，然后访问localhost:2101/consumer，此时可以获取正常的返回，比如：Services: [eureka-consumer-ribbon-hystrix, eureka-client]。</p>
<p>为了触发服务降级逻辑，我们可以将服务提供者eureka-client的逻辑加一些延迟，比如：</p>
<p>@GetMapping(&quot;/dc&quot;)<br />public String dc() throws InterruptedException {<br />Thread.sleep(5000L);<br />String services = &quot;Services: &quot; + discoveryClient.getServices();<br />System.out.println(services);<br />return services;<br />}<br />重启eureka-client之后，再尝试访问localhost:2101/consumer，此时我们将获得的返回结果为：fallback。我们从eureka-client的控制台中，可以看到服务提供方输出了原本要返回的结果，但是由于返回前延迟了5秒，而服务消费方触发了服务请求超时异常，服务消费者就通过HystrixCommand注解中指定的降级逻辑进行执行，因此该请求的结果返回了fallback。这样的机制，对自身服务起到了基础的保护，同时还为异常情况提供了自动的服务降级切换机制。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaTIuNTFjdG8uY29tL2ltYWdlcy9ibG9nLzIwMTgwNi8yNy81M2VjMmI2MTk3MjgwZmNlZDQ3YTA0ZGM0YmQxMjE4Ny5wbmc/eC1vc3MtcHJvY2Vzcz1pbWFnZS93YXRlcm1hcmssc2l6ZV8xNix0ZXh0X1FEVXhRMVJQNVkyYTVhNmksY29sb3JfRkZGRkZGLHRfMTAwLGdfc2UseF8xMCx5XzEwLHNoYWRvd185MCx0eXBlX1ptRnVaM3BvWlc1bmFHVnBkR2s9.jpg" /></p>
<p>从现在开始，我这边会将近期研发的springcloud微服务云架构的搭建过程和精髓记录下来，帮助更多有兴趣研发spring cloud框架的朋友，希望可以帮助更多的好学者。大家来一起探讨spring cloud架构的搭建过程及如何运用于企业项目。</p>
<p>完整项目的源码来源 技术支持求求1791743380</p>

<p>原文地址：http://blog.51cto.com/13545858/2133049</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-12 23:34:05 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/system/" title="system">system</a>, <a href="https://www.biecuoliao.com/tag/%e9%a1%b9%e7%9b%ae/" title="项目">项目</a>, <a href="https://www.biecuoliao.com/tag/src/" title="src">src</a>, <a href="https://www.biecuoliao.com/tag/ack/" title="ack">ack</a>, <a href="https://www.biecuoliao.com/tag/document/" title="document">document</a>, <a href="https://www.biecuoliao.com/tag/ffffff/" title="ffffff">ffffff</a>, <a href="https://www.biecuoliao.com/tag/%e6%8e%a5%e4%b8%8b%e6%9d%a5/" title="接下来">接下来</a>, <a href="https://www.biecuoliao.com/tag/sha/" title="sha">sha</a>, <a href="https://www.biecuoliao.com/tag/%e6%9c%8d%e5%8a%a1%e7%9b%91%e6%8e%a7/" title="服务监控">服务监控</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Spring Cloud构建微服务架构-Hystrix服务降级的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyR2np0.html" rel="bookmark">Spring Cloud构建微服务架构 服务容错保护（Hystrix断路器）【Dalston版】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 在前两篇&lt;Spring Cloud构建微服务架构:服务容错保护(Hystrix服务降级)&gt;和&lt;Spring Cloud构建微服务架构:服务容错保护(Hystrix依赖隔离)&gt;中,我们对Hystrix提供的服务降级和依赖隔离有了基本的认识.下面我们将继续说说Hystrix的另外一个重要元件:断路器. 断路器 断路器模式源于Martin Fowler的Circuit Breaker一文.&quot;断路器&quot;本身是一种开关装置,用于在电路上保护线路过载,当线路中有电器发生			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MD8Ye9M.html" rel="bookmark">Spring Cloud构建微服务架构（一）&mdash;&mdash;服务注册与发现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spring Cloud简介 Spring Cloud是一个基于Spring Boot实现的云应用开发工具,它为基于JVM的云应用开发中的配置管理.服务发现.断路器.智能路由.微代理.控制总线.全局锁.决策竞选.分布式会话和集群状态管理等操作提供了一种简单的开发方式. Spring Cloud包含了多个子项目(针对分布式系统中涉及的多个不同开源产品),比如:Spring Cloud Config.Spring Cloud Netflix.Spring Cloud CloudFoundry.Spr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38DKxn3.html" rel="bookmark">Spring Cloud构建微服务架构（一）服务注册与发现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文来源:http://blog.didispace.com/springcloud1/ Spring Cloud简介 Spring Cloud是一个基于Spring Boot实现的云应用开发工具,它为基于JVM的云应用开发中的配置管理.服务发现.断路器.智能路由.微代理.控制总线.全局锁.决策竞选.分布式会话和集群状态管理等操作提供了一种简单的开发方式. Spring Cloud包含了多个子项目(针对分布式系统中涉及的多个不同开源产品),比如:Spring Cloud Config.Sprin			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M67lE50.html" rel="bookmark">Spring Cloud构建微服务架构服务注册与发现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spring Cloud简介Spring Cloud是一个基于Spring Boot实现的云应用开发工具,它为基于JVM的云应用开发中涉及的配置管理.服务发现.断路器.智能路由.微代理.控制总线.全局锁.决策竞选.分布式会话和集群状态管理等操作提供了一种简单的开发方式. Spring Cloud包含了多个子项目(针对分布式系统中涉及的多个不同开源产品),比如:Spring Cloud Config.Spring Cloud Netflix.Spring Cloud0 CloudFoundry.S			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mgx9Gr0.html" rel="bookmark">java版b2b2c社交电商Spring Cloud构建微服务架构-服务注册与发现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spring Cloud简介Spring Cloud是一个基于Spring Boot实现的云应用开发工具,它为基于JVM的云应用开发中涉及的配置管理.服务发现.断路器.智能路由.微代理.控制总线.全局锁.决策竞选.分布式会话和集群状态管理等操作提供了一种简单的开发方式. Spring Cloud包含了多个子项目(针对分布式系统中涉及的多个不同开源产品),比如:Spring Cloud Config.Spring Cloud Netflix.Spring Cloud0 CloudFoundry.S			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmlARB4.html" rel="bookmark">Spring Cloud构建微服务架构（四）分布式配置中心</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Spring Cloud Config为服务端和客户端提供了分布式系统的外部化配置支持.配置服务器为各应用的所有环境提供了一个中心化的外部配置.它实现了对服务端和客户端对Spring Environment和PropertySource抽象的映射,所以它除了适用于Spring构建的应用程序,也可以在任何其他语言运行的应用程序中使用.作为一个应用可以通过部署管道来进行测试或者投入生产,我们可以分别为这些环境创建配置,并且在需要迁移环境的时候获取对应环境的配置来运行. 配置服务器默认采用git来存储			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dkPW7M.html" rel="bookmark">基于Spring Boot&plus;Cloud构建微云架构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 首先,最想说的是,当你要学习一套最新的技术时,官网的英文文档是学习的最佳渠道.因为网上流传的多数资料是官网翻译而来,很多描述的重点也都偏向于作者自身碰到的问题,这样就很容易让你理解和操作出现偏差,最开始我就进入了这样误区.官网的技术导读真的描述的很详细,虽然对于我们看英文很费劲,但如果英文不是很差,请选择沉下心去读,你一定能收获好多. 我的学习是先从Spring boot开始的,然后接触到微服务架构,当然,这一切最大的启迪还是感谢我的一个老师,是他给我指明了新的道路,让我眼前一亮,再次感谢			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXwlVQ4.html" rel="bookmark">Spring Cloud构建微服务架构&mdash;Hystrix断路器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				断路器模式源于Martin Fowler的Circuit Breaker一文.&quot;断路器&quot;本身是一种开关装置,用于在电路上保护线路过载,当线路中有电器发生短路时,&quot;断路器&quot;能够及时的切断故障电路,防止发生过载.发热.甚至起火等严重后果. 在分布式架构中,断路器模式的作用也是类似的,当某个服务单元发生故障(类似用电器发生短路)之后,通过断路器的故障监控(类似熔断保险丝),直接切断原来的主逻辑调用.但是,在Hystrix中的断路器除了切断主逻辑的功能之外,还有更复杂的逻辑			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4p6NBo0.html" rel="bookmark">Spring Cloud构建微服务架构Hystrix监控面板</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Spring Cloud中构建一个Hystrix Dashboard非常简单,只需要下面四步: 创建一个标准的Spring Boot工程,命名为:hystrix-dashboard.编辑pom.xml,具体依赖内容如下: &lt;parent&gt; &lt;groupId&gt;org.springframework.cloud&lt;/groupId&gt; &lt;artifactId&gt;spring-cloud-starter-parent&lt;/artifactId&gt; &lt;ve			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/W0jQpWM.html" rel="bookmark" class="title">Azure SQL Database &lpar;1&rpar; 用户手册</a>
					<div>
						&lt;Windows Azure Platform 系列文章目录&gt; 下载地址:Azure SQL Database用户手册					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoQYJD3.html" rel="bookmark" class="title">堆排序（Heap Sort）的C语言实现</a>
					<div>
						堆排序(Heap Sort)具体步骤为 将无序序列建成大顶堆(小顶堆):从最后一个非叶子节点开始通过堆调整HeapAdjust()变成小顶堆或大顶堆 将顶部元素与堆尾数组交换,此是末尾元素就是最大值, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXYbjq0.html" rel="bookmark" class="title">SecureCRT&amp;amp&semi;SecureFX&lowbar;v7&period;2&period;5&lowbar;x86&amp;amp&semi;x64&lowbar;build&lowbar;524 破解安装教程</a>
					<div>
						SecureCRT 软件简介 SecureCRT是一款支持SSH(SSH1和SSH2)的终端仿真程序,简单地说是Windows下登录UNIX或Linux服务器主机的软件. SecureCRT是一款支持 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wrO6Z0.html" rel="bookmark" class="title">Perf工具</a>
					<div>
						前段时间Linux下用nmon监控程序的运行,发现CPU的使用率很高,系统态Sys的比例很高.程序的速度不是很快,怀疑和上面的原因有关. 分别使用perf record,perf report和top ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QA8de4.html" rel="bookmark" class="title">React Native Android Gradle 编译流程浅析</a>
					<div>
						[工匠若水 http://blog.csdn.net/yanbober 未经允许严禁转载,请尊重作者劳动成果.私信联系我] 1 背景 前面已经发车了一篇&lt;React Native Android ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M62orJM.html" rel="bookmark" class="title">06 变量和引用</a>
					<div>
						变量 linux 中变量分为, 本地变量, 环境变量, 位置变量 本地变量: 类似C 中的局部变量, 在新启动的shell中不存在, 只有当前shell中先定义了, 之后才能引用 环境变量: 适用于所 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M62kPJM.html" rel="bookmark" class="title">IP分片</a>
					<div>
						当数据超过底层允许最大字节时(一个以太帧1514字节,14字节以太首部,20字节IP首部,UDP8/TCP20,因此IP包每次最大为1500==MTU.去掉协议头UDP有效数据1472字节,TCP为1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz19Y84.html" rel="bookmark" class="title">TzJson</a>
					<div>
						1. package z_utils; import java.net.URLDecoder; public class TzJson { public static void main(String ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dNYez4.html" rel="bookmark" class="title">Swift UI开发初探</a>
					<div>
						今天凌晨Apple刚刚发布了Swift编程语言,Swift是供iOS和OS X应用编程的新编程语言.相信很多开发者都在学习这门新语言. 废话不多说,下面我就来学习使用Swift创建一个简单的UI应用程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzL59J3.html" rel="bookmark" class="title">&lpar;转&rpar;LINUX CENTOS7下安装PYTHON</a>
					<div>
						LINUX CENTOS7下安装PYTHON 原文:http://www.cnblogs.com/lclq/p/5620196.html Posted on 2016-06-27 14:58 南宫羽香 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWV2xb4.html" rel="bookmark" class="title">Appium中部分api的使用方法</a>
					<div>
						使用的语言是java,appium的版本是1.3.4,java-client的版本是java-client-2.1.0,建议多参考java-client-2.1.0-javadoc. 1.使用Andr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AA5wb4.html" rel="bookmark" class="title">SDUT 3403 数据结构实验之排序六：希尔排序</a>
					<div>
						数据结构实验之排序六:希尔排序 Time Limit: 1000MS Memory Limit: 65536KB Submit Statistic Problem Description 我们已经学习 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzEEwk4.html" rel="bookmark" class="title">&lbrack;转&rsqb;C 语言指针的使用组罪驻酌祝淄</a>
					<div>
						今天有幸被召回母校给即将毕业的学弟学妹们讲我这两年的工作史,看了下母校没啥特别的变化,就是寝室都安了空调,学妹们都非常漂亮而已..好了不扯蛋了,说下今天的主题吧.这些天我在深度定制语法高亮功能的同时发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38pA7l3.html" rel="bookmark" class="title">CentOS 6&period;2 Eclipse CDT 开发环境搭建</a>
					<div>
						一.安装中文语言支撑 我当初安装CentOS6.2时选择了中文语言支持,有iBus和拼音输入法,有gnome和kde 没有安装的可以参考:CentOS英文环境下使用中文输入法  安装中文语言支持和输入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/351VDR3.html" rel="bookmark" class="title">（转载）虚幻引擎3--2掌握虚幻技术UnrealScript初级学习</a>
					<div>
						第二章: UNREALSCRIPT的初级学习 2.1基本语法 标识符和关键字 表达式和操作符 注释 2.2再生MUTATOR(设置方法) 设计类的计划 指南 2.1 –研究再生Mutaor(设置方法) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AWV9D0.html" rel="bookmark" class="title">今日竞赛&mdash;解题报告</a>
					<div>
						B - B Time Limit:2000MS     Memory Limit:262144KB     64bit IO Format:%I64d &amp; %I64u Submit Statu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzB7P8M.html" rel="bookmark" class="title">005-Scala数组操作实战详解</a>
					<div>
						005-Scala数组操作实战详解 Worksheet的使用 交互式命令执行平台 记得每次要保存才会出相应的结果 数组的基本操作 数组的下标是从0开始和Tuple不同 缓冲数组ArrayBuffer( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xmGEk3.html" rel="bookmark" class="title">HDU5100Chessboard（数论）</a>
					<div>
						题目链接 题目大意:用k?1的瓷砖区铺n?n的矩形,问能铺上的最大的面积. 解题思路:这题没有直接得出结论:l = n%k, ans = max[(n^2 - l^2), (n^2 - (k - l) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rqJNX0.html" rel="bookmark" class="title">开发界面调试工具-Reveal的详细安装使用</a>
					<div>
						Reveal作为分析APP UI的利器确实非常好用,用来查看任意UI布局也很方便 一.模拟器进行分析 1.打开Reveal(http://revealapp.com下载) 2.打开Xcode 3.Re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXzVna3.html" rel="bookmark" class="title">SqlServer 日志清除</a>
					<div>
						在SqlServer中清除日志就必须在简单模式下进行,等清除动作完毕再调回到完全模式. *[DataBaseName]要压缩日志的数据库名称. 设置数据库模式为简单模式 ALTER DATABASE  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
